package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.graphics.Point;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of RelativeAttachment.
 * It implements the widgets and models of the page.
 *
 */
public abstract class RelativeAttachmentGen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    Group relativeAttachment_composite_0_0W;
    Text t1aW;
    ISimpleWMClient t1a;
    Text t1bW;
    ISimpleWMClient t1b;
    Text t1cW;
    ISimpleWMClient t1c;
    Text t1dW;
    ISimpleWMClient t1d;
    Label customer1_firstNameL;
    Text customer1_firstNameW;
    ISimpleWMClient customer1_firstName;
    Group relativeAttachment_composite_1_0W;
    Composite relativeAttachment_composite_1_0_set0W;
    Label relativeAttachment_composite_1_0_set0_centered;
    Text t2bW;
    ISimpleWMClient t2b;
    Composite relativeAttachment_composite_1_0_set1W;
    Label relativeAttachment_composite_1_0_set1_centered;
    Text t2cW;
    ISimpleWMClient t2c;
    ScrolledComposite scrolledrelativeAttachment_composite_2_0W;
    Group relativeAttachment_composite_2_0W;
    Composite relativeAttachment_composite_2_0_set0W;
    Label relativeAttachment_composite_2_0_set0_centered;
    Text t3aW;
    ISimpleWMClient t3a;
    Composite relativeAttachment_composite_2_0_set1W;
    Label relativeAttachment_composite_2_0_set1_centered;
    Text t3bW;
    ISimpleWMClient t3b;
    Composite relativeAttachment_composite_2_0_set2W;
    Label relativeAttachment_composite_2_0_set2_centered;
    Text t3cW;
    ISimpleWMClient t3c;
    ScrolledComposite scrolledrelativeAttachment_composite_3_0W;
    Group relativeAttachment_composite_3_0W;
    Composite relativeAttachment_composite_3_0_set0W;
    Label relativeAttachment_composite_3_0_set0_centered;
    Text t4aW;
    ISimpleWMClient t4a;
    Composite relativeAttachment_composite_3_0_set1W;
    Label relativeAttachment_composite_3_0_set1_centered;
    Text t4bW;
    ISimpleWMClient t4b;
    ScrolledComposite scrolledrelativeAttachment_composite_4_0W;
    Group relativeAttachment_composite_4_0W;
    Composite relativeAttachment_composite_4_0_set0W;
    Label relativeAttachment_composite_4_0_set0_centered;
    Text t5aW;
    ISimpleWMClient t5a;
    Composite relativeAttachment_composite_4_0_set1W;
    Label relativeAttachment_composite_4_0_set1_centered;
    Text t5bW;
    ISimpleWMClient t5b;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the RelativeAttachmentGen.
     * @param notebook the Notebook this page belongs to.
     */
    public RelativeAttachmentGen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        Locale locale = getComponent().getContext().getLocale();
        IFmt formatter;
        CompoundValidator compound;
        t1a = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1a.setFmt(formatter);
        t1b = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1b.setFmt(formatter);
        t1c = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1c.setFmt(formatter);
        t1d = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1d.setFmt(formatter);
        customer1_firstName = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_firstName.setFmt(formatter);
        t2b = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2b.setFmt(formatter);
        t2c = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t2c.setFmt(formatter);
        t3a = new SimpleWMClient((short) 7, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3a.setFmt(formatter);
        t3b = new SimpleWMClient((short) 8, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3b.setFmt(formatter);
        t3c = new SimpleWMClient((short) 9, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t3c.setFmt(formatter);
        t4a = new SimpleWMClient((short) 10, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t4a.setFmt(formatter);
        t4b = new SimpleWMClient((short) 11, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t4b.setFmt(formatter);
        t5a = new SimpleWMClient((short) 12, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t5a.setFmt(formatter);
        t5b = new SimpleWMClient((short) 13, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t5b.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1d, (WModel) customer1_firstName, (WModel) t2b, (WModel) t2c, (WModel) t3a, (WModel) t3b, (WModel) t3c, (WModel) t4a, (WModel) t4b, (WModel) t5a, (WModel) t5b };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        t1a = null;
        t1b = null;
        t1c = null;
        t1d = null;
        customer1_firstName = null;
        t2b = null;
        t2c = null;
        t3a = null;
        t3b = null;
        t3c = null;
        t4a = null;
        t4b = null;
        t5a = null;
        t5b = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.RelativeAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",locale);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        Composite pageCompositerelativeAttachmentW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositerelativeAttachmentW.setLayout(layout);

        relativeAttachment_composite_0_0W = new Group(pageCompositerelativeAttachmentW,SWT.NONE);
        relativeAttachment_composite_0_0W.setText(messages.getString("RelativeAttachment.relativeAttachment_composite_0_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        relativeAttachment_composite_0_0W.setLayout(layout);

        t1aW = new Text(relativeAttachment_composite_0_0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1aW.setData("WIDGET_ID","t1aW");
        t1aW.addFocusListener(adapter);
        t1aW.addModifyListener(adapter);
        t1aW.addVerifyListener(adapter);

        t1bW = new Text(relativeAttachment_composite_0_0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1bW.setData("WIDGET_ID","t1bW");
        t1bW.addFocusListener(adapter);
        t1bW.addModifyListener(adapter);
        t1bW.addVerifyListener(adapter);

        t1cW = new Text(relativeAttachment_composite_0_0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1cW.setData("WIDGET_ID","t1cW");
        t1cW.addFocusListener(adapter);
        t1cW.addModifyListener(adapter);
        t1cW.addVerifyListener(adapter);

        t1dW = new Text(relativeAttachment_composite_0_0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1dW.setData("WIDGET_ID","t1dW");
        t1dW.addFocusListener(adapter);
        t1dW.addModifyListener(adapter);
        t1dW.addVerifyListener(adapter);

        customer1_firstNameL = new Label (relativeAttachment_composite_0_0W,SWT.LEFT|SWT.WRAP);
        customer1_firstNameL.setText(messages.getString("RelativeAttachment.customer1_firstNameL"));
        customer1_firstNameL.setData("WIDGET_ID","customer1_firstNameL");

        customer1_firstNameW = new Text(relativeAttachment_composite_0_0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer1_firstNameW.setToolTipText(messages.getString("RelativeAttachment.customer1_firstNameWTip"));
        customer1_firstNameW.setData("WIDGET_ID","customer1_firstNameW");
        customer1_firstNameW.addFocusListener(adapter);
        customer1_firstNameW.addModifyListener(adapter);
        customer1_firstNameW.addVerifyListener(adapter);

        relativeAttachment_composite_1_0W = new Group(pageCompositerelativeAttachmentW,SWT.NONE);
        relativeAttachment_composite_1_0W.setText(messages.getString("RelativeAttachment.relativeAttachment_composite_1_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        relativeAttachment_composite_1_0W.setLayout(layout);

        relativeAttachment_composite_1_0_set0W = new Composite(relativeAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_1_0_set0W.setLayout(layout);
        relativeAttachment_composite_1_0_set0W.setData("WIDGET_ID","relativeAttachment_composite_1_0_set0W");

        relativeAttachment_composite_1_0_set0_centered = new Label (relativeAttachment_composite_1_0_set0W,SWT.LEFT);
        relativeAttachment_composite_1_0_set0_centered.setVisible(false);
        relativeAttachment_composite_1_0_set0_centered.setData("WIDGET_ID","relativeAttachment_composite_1_0_set0_centered");

        t2bW = new Text(relativeAttachment_composite_1_0_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2bW.setData("WIDGET_ID","t2bW");
        t2bW.addFocusListener(adapter);
        t2bW.addModifyListener(adapter);
        t2bW.addVerifyListener(adapter);

        relativeAttachment_composite_1_0_set1W = new Composite(relativeAttachment_composite_1_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_1_0_set1W.setLayout(layout);
        relativeAttachment_composite_1_0_set1W.setData("WIDGET_ID","relativeAttachment_composite_1_0_set1W");

        relativeAttachment_composite_1_0_set1_centered = new Label (relativeAttachment_composite_1_0_set1W,SWT.LEFT);
        relativeAttachment_composite_1_0_set1_centered.setVisible(false);
        relativeAttachment_composite_1_0_set1_centered.setData("WIDGET_ID","relativeAttachment_composite_1_0_set1_centered");

        t2cW = new Text(relativeAttachment_composite_1_0_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t2cW.setData("WIDGET_ID","t2cW");
        t2cW.addFocusListener(adapter);
        t2cW.addModifyListener(adapter);
        t2cW.addVerifyListener(adapter);

        scrolledrelativeAttachment_composite_2_0W = new ScrolledComposite(pageCompositerelativeAttachmentW,SWT.NONE|SWT.H_SCROLL|SWT.V_SCROLL);
        scrolledrelativeAttachment_composite_2_0W.setExpandHorizontal(true);
        scrolledrelativeAttachment_composite_2_0W.setExpandVertical(true);
        scrolledrelativeAttachment_composite_2_0W.setData("WIDGET_ID","scrolledrelativeAttachment_composite_2_0W");

        relativeAttachment_composite_2_0W = new Group(scrolledrelativeAttachment_composite_2_0W,SWT.NONE);
        relativeAttachment_composite_2_0W.setText(messages.getString("RelativeAttachment.relativeAttachment_composite_2_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        relativeAttachment_composite_2_0W.setLayout(layout);

        relativeAttachment_composite_2_0_set0W = new Composite(relativeAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_2_0_set0W.setLayout(layout);
        relativeAttachment_composite_2_0_set0W.setData("WIDGET_ID","relativeAttachment_composite_2_0_set0W");

        relativeAttachment_composite_2_0_set0_centered = new Label (relativeAttachment_composite_2_0_set0W,SWT.LEFT);
        relativeAttachment_composite_2_0_set0_centered.setVisible(false);
        relativeAttachment_composite_2_0_set0_centered.setData("WIDGET_ID","relativeAttachment_composite_2_0_set0_centered");

        t3aW = new Text(relativeAttachment_composite_2_0_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3aW.setData("WIDGET_ID","t3aW");
        t3aW.addFocusListener(adapter);
        t3aW.addModifyListener(adapter);
        t3aW.addVerifyListener(adapter);

        relativeAttachment_composite_2_0_set1W = new Composite(relativeAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_2_0_set1W.setLayout(layout);
        relativeAttachment_composite_2_0_set1W.setData("WIDGET_ID","relativeAttachment_composite_2_0_set1W");

        relativeAttachment_composite_2_0_set1_centered = new Label (relativeAttachment_composite_2_0_set1W,SWT.LEFT);
        relativeAttachment_composite_2_0_set1_centered.setVisible(false);
        relativeAttachment_composite_2_0_set1_centered.setData("WIDGET_ID","relativeAttachment_composite_2_0_set1_centered");

        t3bW = new Text(relativeAttachment_composite_2_0_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3bW.setData("WIDGET_ID","t3bW");
        t3bW.addFocusListener(adapter);
        t3bW.addModifyListener(adapter);
        t3bW.addVerifyListener(adapter);

        relativeAttachment_composite_2_0_set2W = new Composite(relativeAttachment_composite_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_2_0_set2W.setLayout(layout);
        relativeAttachment_composite_2_0_set2W.setData("WIDGET_ID","relativeAttachment_composite_2_0_set2W");

        relativeAttachment_composite_2_0_set2_centered = new Label (relativeAttachment_composite_2_0_set2W,SWT.LEFT);
        relativeAttachment_composite_2_0_set2_centered.setVisible(false);
        relativeAttachment_composite_2_0_set2_centered.setData("WIDGET_ID","relativeAttachment_composite_2_0_set2_centered");

        t3cW = new Text(relativeAttachment_composite_2_0_set2W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t3cW.setData("WIDGET_ID","t3cW");
        t3cW.addFocusListener(adapter);
        t3cW.addModifyListener(adapter);
        t3cW.addVerifyListener(adapter);

        scrolledrelativeAttachment_composite_3_0W = new ScrolledComposite(pageCompositerelativeAttachmentW,SWT.NONE|SWT.H_SCROLL|SWT.V_SCROLL);
        scrolledrelativeAttachment_composite_3_0W.setExpandHorizontal(true);
        scrolledrelativeAttachment_composite_3_0W.setExpandVertical(true);
        scrolledrelativeAttachment_composite_3_0W.setData("WIDGET_ID","scrolledrelativeAttachment_composite_3_0W");

        relativeAttachment_composite_3_0W = new Group(scrolledrelativeAttachment_composite_3_0W,SWT.NONE);
        relativeAttachment_composite_3_0W.setText(messages.getString("RelativeAttachment.relativeAttachment_composite_3_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        relativeAttachment_composite_3_0W.setLayout(layout);

        relativeAttachment_composite_3_0_set0W = new Composite(relativeAttachment_composite_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_3_0_set0W.setLayout(layout);
        relativeAttachment_composite_3_0_set0W.setData("WIDGET_ID","relativeAttachment_composite_3_0_set0W");

        relativeAttachment_composite_3_0_set0_centered = new Label (relativeAttachment_composite_3_0_set0W,SWT.LEFT);
        relativeAttachment_composite_3_0_set0_centered.setVisible(false);
        relativeAttachment_composite_3_0_set0_centered.setData("WIDGET_ID","relativeAttachment_composite_3_0_set0_centered");

        t4aW = new Text(relativeAttachment_composite_3_0_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t4aW.setData("WIDGET_ID","t4aW");
        t4aW.addFocusListener(adapter);
        t4aW.addModifyListener(adapter);
        t4aW.addVerifyListener(adapter);

        relativeAttachment_composite_3_0_set1W = new Composite(relativeAttachment_composite_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_3_0_set1W.setLayout(layout);
        relativeAttachment_composite_3_0_set1W.setData("WIDGET_ID","relativeAttachment_composite_3_0_set1W");

        relativeAttachment_composite_3_0_set1_centered = new Label (relativeAttachment_composite_3_0_set1W,SWT.LEFT);
        relativeAttachment_composite_3_0_set1_centered.setVisible(false);
        relativeAttachment_composite_3_0_set1_centered.setData("WIDGET_ID","relativeAttachment_composite_3_0_set1_centered");

        t4bW = new Text(relativeAttachment_composite_3_0_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t4bW.setData("WIDGET_ID","t4bW");
        t4bW.addFocusListener(adapter);
        t4bW.addModifyListener(adapter);
        t4bW.addVerifyListener(adapter);

        scrolledrelativeAttachment_composite_4_0W = new ScrolledComposite(pageCompositerelativeAttachmentW,SWT.NONE|SWT.H_SCROLL|SWT.V_SCROLL);
        scrolledrelativeAttachment_composite_4_0W.setExpandHorizontal(true);
        scrolledrelativeAttachment_composite_4_0W.setExpandVertical(true);
        scrolledrelativeAttachment_composite_4_0W.setData("WIDGET_ID","scrolledrelativeAttachment_composite_4_0W");

        relativeAttachment_composite_4_0W = new Group(scrolledrelativeAttachment_composite_4_0W,SWT.NONE);
        relativeAttachment_composite_4_0W.setText(messages.getString("RelativeAttachment.relativeAttachment_composite_4_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        relativeAttachment_composite_4_0W.setLayout(layout);

        relativeAttachment_composite_4_0_set0W = new Composite(relativeAttachment_composite_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_4_0_set0W.setLayout(layout);
        relativeAttachment_composite_4_0_set0W.setData("WIDGET_ID","relativeAttachment_composite_4_0_set0W");

        relativeAttachment_composite_4_0_set0_centered = new Label (relativeAttachment_composite_4_0_set0W,SWT.LEFT);
        relativeAttachment_composite_4_0_set0_centered.setVisible(false);
        relativeAttachment_composite_4_0_set0_centered.setData("WIDGET_ID","relativeAttachment_composite_4_0_set0_centered");

        t5aW = new Text(relativeAttachment_composite_4_0_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t5aW.setData("WIDGET_ID","t5aW");
        t5aW.addFocusListener(adapter);
        t5aW.addModifyListener(adapter);
        t5aW.addVerifyListener(adapter);

        relativeAttachment_composite_4_0_set1W = new Composite(relativeAttachment_composite_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        relativeAttachment_composite_4_0_set1W.setLayout(layout);
        relativeAttachment_composite_4_0_set1W.setData("WIDGET_ID","relativeAttachment_composite_4_0_set1W");

        relativeAttachment_composite_4_0_set1_centered = new Label (relativeAttachment_composite_4_0_set1W,SWT.LEFT);
        relativeAttachment_composite_4_0_set1_centered.setVisible(false);
        relativeAttachment_composite_4_0_set1_centered.setData("WIDGET_ID","relativeAttachment_composite_4_0_set1_centered");

        t5bW = new Text(relativeAttachment_composite_4_0_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t5bW.setData("WIDGET_ID","t5bW");
        t5bW.addFocusListener(adapter);
        t5bW.addModifyListener(adapter);
        t5bW.addVerifyListener(adapter);

        widgets = new Control[] { relativeAttachment_composite_0_0W, t1aW, t1bW, t1cW, t1dW, customer1_firstNameL, customer1_firstNameW, relativeAttachment_composite_1_0W, relativeAttachment_composite_1_0_set0W, relativeAttachment_composite_1_0_set0_centered, t2bW, relativeAttachment_composite_1_0_set1W, relativeAttachment_composite_1_0_set1_centered, t2cW, scrolledrelativeAttachment_composite_2_0W, relativeAttachment_composite_2_0W, relativeAttachment_composite_2_0_set0W, relativeAttachment_composite_2_0_set0_centered, t3aW, relativeAttachment_composite_2_0_set1W, relativeAttachment_composite_2_0_set1_centered, t3bW, relativeAttachment_composite_2_0_set2W, relativeAttachment_composite_2_0_set2_centered, t3cW, scrolledrelativeAttachment_composite_3_0W, relativeAttachment_composite_3_0W, relativeAttachment_composite_3_0_set0W, relativeAttachment_composite_3_0_set0_centered, t4aW, relativeAttachment_composite_3_0_set1W, relativeAttachment_composite_3_0_set1_centered, t4bW, scrolledrelativeAttachment_composite_4_0W, relativeAttachment_composite_4_0W, relativeAttachment_composite_4_0_set0W, relativeAttachment_composite_4_0_set0_centered, t5aW, relativeAttachment_composite_4_0_set1W, relativeAttachment_composite_4_0_set1_centered, t5bW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(-2));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_0_0W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(5,100,scaler.convertYToCurrent(0));
        t1aW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(t1aW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1bW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(t1bW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(10));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(t1cW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1dW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(-10));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(t1dW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        customer1_firstNameL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(-10));
        data.right = new FormAttachment(70,100,scaler.convertXToCurrent(10));
        data.top = new FormAttachment(customer1_firstNameL,scaler.convertYToCurrent(3),SWT.BOTTOM);
        customer1_firstNameW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(50,100,scaler.convertXToCurrent(2));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_1_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_1_0_set0W.setLayoutData(data);
        lastControl=relativeAttachment_composite_1_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        relativeAttachment_composite_1_0_set1W.setLayoutData(data);
        lastControl=relativeAttachment_composite_1_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_1_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_1_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t2bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_1_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(10);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_1_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t2cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(50,100,scaler.convertXToCurrent(2));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_1_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        scrolledrelativeAttachment_composite_2_0W.setLayoutData(data);


        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_2_0_set0W.setLayoutData(data);
        lastControl=relativeAttachment_composite_2_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        relativeAttachment_composite_2_0_set1W.setLayoutData(data);
        lastControl=relativeAttachment_composite_2_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        relativeAttachment_composite_2_0_set2W.setLayoutData(data);
        lastControl=relativeAttachment_composite_2_0_set2W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_2_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(40);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_2_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_2_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(40);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_2_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_2_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_2_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t3cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(50,100,scaler.convertXToCurrent(2));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(scrolledrelativeAttachment_composite_2_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        scrolledrelativeAttachment_composite_3_0W.setLayoutData(data);


        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_3_0_set0W.setLayoutData(data);
        lastControl=relativeAttachment_composite_3_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        relativeAttachment_composite_3_0_set1W.setLayoutData(data);
        lastControl=relativeAttachment_composite_3_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_3_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(40);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_3_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t4aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_3_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(40);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_3_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t4bW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(50,100,scaler.convertXToCurrent(2));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(scrolledrelativeAttachment_composite_3_0W,scaler.convertYToCurrent(0),SWT.BOTTOM);
        scrolledrelativeAttachment_composite_4_0W.setLayoutData(data);


        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_4_0_set0W.setLayoutData(data);
        lastControl=relativeAttachment_composite_4_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        relativeAttachment_composite_4_0_set1W.setLayoutData(data);
        lastControl=relativeAttachment_composite_4_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_4_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(300);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_4_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t5aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        relativeAttachment_composite_4_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(300);
        data.left = new FormAttachment(5,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(90,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(relativeAttachment_composite_4_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t5bW.setLayoutData(data);


        scrolledrelativeAttachment_composite_2_0W.setContent(relativeAttachment_composite_2_0W);
        Point size = relativeAttachment_composite_2_0W.computeSize(SWT.DEFAULT,SWT.DEFAULT);
        scrolledrelativeAttachment_composite_2_0W.setMinSize(size);

        scrolledrelativeAttachment_composite_3_0W.setContent(relativeAttachment_composite_3_0W);
        size = relativeAttachment_composite_3_0W.computeSize(SWT.DEFAULT,SWT.DEFAULT);
        scrolledrelativeAttachment_composite_3_0W.setMinSize(size);

        scrolledrelativeAttachment_composite_4_0W.setContent(relativeAttachment_composite_4_0W);
        size = relativeAttachment_composite_4_0W.computeSize(SWT.DEFAULT,SWT.DEFAULT);
        scrolledrelativeAttachment_composite_4_0W.setMinSize(size);

        tabOrder = new Control[5];
        tabOrder[0] = relativeAttachment_composite_0_0W;
        tabOrder[1] = relativeAttachment_composite_1_0W;
        tabOrder[2] = scrolledrelativeAttachment_composite_2_0W;
        tabOrder[3] = scrolledrelativeAttachment_composite_3_0W;
        tabOrder[4] = scrolledrelativeAttachment_composite_4_0W;
        pageCompositerelativeAttachmentW.setTabList(tabOrder);
        tabOrder = new Control[5];
        tabOrder[0] = t1aW;
        tabOrder[1] = t1bW;
        tabOrder[2] = t1cW;
        tabOrder[3] = t1dW;
        tabOrder[4] = customer1_firstNameW;
        relativeAttachment_composite_0_0W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = relativeAttachment_composite_1_0_set0W;
        tabOrder[1] = relativeAttachment_composite_1_0_set1W;
        relativeAttachment_composite_1_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2bW;
        relativeAttachment_composite_1_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t2cW;
        relativeAttachment_composite_1_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[3];
        tabOrder[0] = relativeAttachment_composite_2_0_set0W;
        tabOrder[1] = relativeAttachment_composite_2_0_set1W;
        tabOrder[2] = relativeAttachment_composite_2_0_set2W;
        relativeAttachment_composite_2_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3aW;
        relativeAttachment_composite_2_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3bW;
        relativeAttachment_composite_2_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t3cW;
        relativeAttachment_composite_2_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = relativeAttachment_composite_3_0_set0W;
        tabOrder[1] = relativeAttachment_composite_3_0_set1W;
        relativeAttachment_composite_3_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t4aW;
        relativeAttachment_composite_3_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t4bW;
        relativeAttachment_composite_3_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = relativeAttachment_composite_4_0_set0W;
        tabOrder[1] = relativeAttachment_composite_4_0_set1W;
        relativeAttachment_composite_4_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t5aW;
        relativeAttachment_composite_4_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t5bW;
        relativeAttachment_composite_4_0_set1W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        relativeAttachment_composite_0_0W = null;
        t1aW = null;
        t1bW = null;
        t1cW = null;
        t1dW = null;
        customer1_firstNameL = null;
        customer1_firstNameW = null;
        relativeAttachment_composite_1_0W = null;
        relativeAttachment_composite_1_0_set0W = null;
        relativeAttachment_composite_1_0_set0_centered = null;
        t2bW = null;
        relativeAttachment_composite_1_0_set1W = null;
        relativeAttachment_composite_1_0_set1_centered = null;
        t2cW = null;
        scrolledrelativeAttachment_composite_2_0W = null;
        relativeAttachment_composite_2_0W = null;
        relativeAttachment_composite_2_0_set0W = null;
        relativeAttachment_composite_2_0_set0_centered = null;
        t3aW = null;
        relativeAttachment_composite_2_0_set1W = null;
        relativeAttachment_composite_2_0_set1_centered = null;
        t3bW = null;
        relativeAttachment_composite_2_0_set2W = null;
        relativeAttachment_composite_2_0_set2_centered = null;
        t3cW = null;
        scrolledrelativeAttachment_composite_3_0W = null;
        relativeAttachment_composite_3_0W = null;
        relativeAttachment_composite_3_0_set0W = null;
        relativeAttachment_composite_3_0_set0_centered = null;
        t4aW = null;
        relativeAttachment_composite_3_0_set1W = null;
        relativeAttachment_composite_3_0_set1_centered = null;
        t4bW = null;
        scrolledrelativeAttachment_composite_4_0W = null;
        relativeAttachment_composite_4_0W = null;
        relativeAttachment_composite_4_0_set0W = null;
        relativeAttachment_composite_4_0_set0_centered = null;
        t5aW = null;
        relativeAttachment_composite_4_0_set1W = null;
        relativeAttachment_composite_4_0_set1_centered = null;
        t5bW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        t1aW.setData(t1a.getUIDelegate());
        t1a.getUIDelegate().attachUI(t1aW,null);
        t1bW.setData(t1b.getUIDelegate());
        t1b.getUIDelegate().attachUI(t1bW,null);
        t1cW.setData(t1c.getUIDelegate());
        t1c.getUIDelegate().attachUI(t1cW,null);
        t1dW.setData(t1d.getUIDelegate());
        t1d.getUIDelegate().attachUI(t1dW,null);
        customer1_firstNameW.setData(customer1_firstName.getUIDelegate());
        customer1_firstName.getUIDelegate().attachUI(customer1_firstNameW,customer1_firstNameL);
        t2bW.setData(t2b.getUIDelegate());
        t2b.getUIDelegate().attachUI(t2bW,null);
        t2cW.setData(t2c.getUIDelegate());
        t2c.getUIDelegate().attachUI(t2cW,null);
        t3aW.setData(t3a.getUIDelegate());
        t3a.getUIDelegate().attachUI(t3aW,null);
        t3bW.setData(t3b.getUIDelegate());
        t3b.getUIDelegate().attachUI(t3bW,null);
        t3cW.setData(t3c.getUIDelegate());
        t3c.getUIDelegate().attachUI(t3cW,null);
        t4aW.setData(t4a.getUIDelegate());
        t4a.getUIDelegate().attachUI(t4aW,null);
        t4bW.setData(t4b.getUIDelegate());
        t4b.getUIDelegate().attachUI(t4bW,null);
        t5aW.setData(t5a.getUIDelegate());
        t5a.getUIDelegate().attachUI(t5aW,null);
        t5bW.setData(t5b.getUIDelegate());
        t5b.getUIDelegate().attachUI(t5bW,null);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer1_firstName.setMandatory(true);
    }

    /**
     * This method will be called every time the RelativeAttachment becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder LayoutingPage_tabfolder_0_0_0_0W,int index) {
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",locale);

        TabItem relativeAttachmentW = new TabItem (LayoutingPage_tabfolder_0_0_0_0W, SWT.NULL, index);
        relativeAttachmentW.setText(messages.getString("RelativeAttachment"));
        relativeAttachmentW.setControl(getComposite());
        relativeAttachmentW.setData(this);

        return relativeAttachmentW;
    }
}
