package org.openxma.dsl.reference.service;

import java.util.Collection;
import java.util.Date;
import org.openxma.dsl.reference.dto.CustomerView;
import org.openxma.dsl.reference.dto.OrderStateView;
import org.openxma.dsl.reference.dto.OrderView;

public interface OrderServiceGen {
	Collection<OrderStateView> readOrderStateByCustomerAndDate(Long customerId,Date reportDate);
	Collection<OrderView> findAllOrderStatesBetweenDate(OrderView order,Date from,Date to);
	Collection<OrderView> findAllByCustomer(CustomerView customer);
	OrderView save(OrderView orderView);
	OrderView loadOrderView(String oid);
	void update(OrderView orderView);
	void deleteOrder(String oid);
}
